#
#	Copyright (C) 2007, 2008, 2009, 2010. PARP Research Group.
#	<http://perception.inf.um.es>
#	University of Murcia, Spain.
#
#	This file is part of the QVision library.
#
#	QVision is free software: you can redistribute it and/or modify
#	it under the terms of the GNU Lesser General Public License as
#	published by the Free Software Foundation, version 3 of the License.
#
#	QVision is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU Lesser General Public License for more details.
#
#	You should have received a copy of the GNU Lesser General Public
#	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
#

################################
#
#	File qvipp.pri
#

!qvipp_defined {

	INCLUDEPATH += $$PWD
	SOURCEPATH += $$PWD

	!exists($$IPP_PATH): \
		error(In module qvipp: IPP library was not found at specified path: $$IPP_PATH . Set \
			a correct path in the IPP_PATH variable at the config.pri file)
	!exists($$IPP_PATH/include): \
		error(In module qvipp: Include files directory was not found at the specified path for the IPP library: $$IPP_PATH/include . \
			Perhaps it is not the installation directory for the IPP?)
	!exists($$IPP_PATH/sharedlib): \
		error(In module qvipp: Shared library binaries directory was not found at the specified path for the IPP library: \ 
			$$IPP_PATH/sharedlib . Perhaps it is not the installation directory for the IPP?)

	INCLUDEPATH += $$IPP_PATH/include
	unix	{
		LIBS		+= -L$$IPP_PATH/sharedlib
		!icc:LIBS	+= -Wl,-rpath=$$IPP_PATH/sharedlib
		exists($$find(IPP_PATH, em64t)):	LIBS += -lguide -lippiem64t -lippcoreem64t -lippsem64t -lippccem64t -lippvcem64t -lippcvem64t
		exists($$find(IPP_PATH, ia32)):		LIBS += -lguide -lippi -lippcore -lipps -lippcc -lippvc -lippcv
		}
	DEFINES += QVIPP

	CONFIG += qvipp_defined

	HEADERS +=	$$PWD/qvip/qvipp/qvipp.h						\
			$$PWD/qvip/qvipp/qvippfunctions.h
	
	SOURCES +=	$$PWD/qvip/qvipp/qvipp.cpp						\
			$$PWD/qvip/qvipp/qvippfunctions.cpp

	message(Included module: qvipp)
	message(* Path to IPP: $$IPP_PATH)
	}

